Index: /trunk/SophyaLib/BaseTools/fiondblock.cc
===================================================================
--- /trunk/SophyaLib/BaseTools/fiondblock.cc	(revision 3660)
+++ /trunk/SophyaLib/BaseTools/fiondblock.cc	(revision 3661)
@@ -117,4 +117,6 @@
 inline void PIOSReadArray(PInPersist & is, uint_1 * arr, size_t n)
 { is.GetBytes(arr, n); }
+inline void PIOSReadArray(PInPersist & is, int_1 * arr, size_t n)
+{ is.Get(arr, n); }
 inline void PIOSReadArray(PInPersist & is, uint_2 * arr, size_t n)
 { is.Get(arr, n); }
@@ -184,9 +186,10 @@
 #pragma define_template FIO_NDataBlock<uint_1>
 #pragma define_template FIO_NDataBlock<uint_2>
+#pragma define_template FIO_NDataBlock<uint_4>
+#pragma define_template FIO_NDataBlock<uint_8>
+#pragma define_template FIO_NDataBlock<int_1>
 #pragma define_template FIO_NDataBlock<int_2>
 #pragma define_template FIO_NDataBlock<int_4>
 #pragma define_template FIO_NDataBlock<int_8>
-#pragma define_template FIO_NDataBlock<uint_4>
-#pragma define_template FIO_NDataBlock<uint_8>
 #pragma define_template FIO_NDataBlock<r_8>
 #pragma define_template FIO_NDataBlock<r_4>
@@ -200,9 +203,10 @@
 template class FIO_NDataBlock<uint_1>;
 template class FIO_NDataBlock<uint_2>;
+template class FIO_NDataBlock<uint_4>;
+template class FIO_NDataBlock<uint_8>;
+template class FIO_NDataBlock<int_1>;
 template class FIO_NDataBlock<int_2>;
 template class FIO_NDataBlock<int_4>;
 template class FIO_NDataBlock<int_8>;
-template class FIO_NDataBlock<uint_4>;
-template class FIO_NDataBlock<uint_8>;
 template class FIO_NDataBlock<r_8>;
 template class FIO_NDataBlock<r_4>;
Index: /trunk/SophyaLib/BaseTools/mutyv.h
===================================================================
--- /trunk/SophyaLib/BaseTools/mutyv.h	(revision 3660)
+++ /trunk/SophyaLib/BaseTools/mutyv.h	(revision 3661)
@@ -32,7 +32,9 @@
   inline MuTyV() { typ = MTVInteger; iv = 0;  dv = dv_im = 0.;  strv = NULL; }
          MuTyV(MuTyV const & a);
+  inline MuTyV(uint_1 i) { typ = MTVInteger; iv = (int_8)i;  dv = (r_8)i;  dv_im = 0.;  strv = NULL; }
   inline MuTyV(uint_2 i) { typ = MTVInteger; iv = (int_8)i;  dv = (r_8)i;  dv_im = 0.;  strv = NULL; }
   inline MuTyV(uint_4 i) { typ = MTVInteger; iv = (int_8)i;  dv = (r_8)i;  dv_im = 0.;  strv = NULL; }
   inline MuTyV(uint_8 i) { typ = MTVInteger; iv = (int_8)i;  dv = (r_8)i;  dv_im = 0.;  strv = NULL; }
+  inline MuTyV(int_1 i)  { typ = MTVInteger; iv = (int_8)i;  dv = (r_8)i;  dv_im = 0.;  strv = NULL; }
   inline MuTyV(int_2 i)  { typ = MTVInteger; iv = (int_8)i;  dv = (r_8)i;  dv_im = 0.;  strv = NULL; }
   inline MuTyV(int_4 i)  { typ = MTVInteger; iv = (int_8)i;  dv = (r_8)i;  dv_im = 0.;  strv = NULL; }
@@ -52,7 +54,9 @@
  
          MuTyV & operator= (MuTyV const & a);
+  inline MuTyV & operator= (uint_1 v)  { typ = MTVInteger; iv = (int_8)v;  dv = (r_8)v;  dv_im = 0.;  return(*this); }
   inline MuTyV & operator= (uint_2 v)  { typ = MTVInteger; iv = (int_8)v;  dv = (r_8)v;  dv_im = 0.;  return(*this); }
   inline MuTyV & operator= (uint_4 v)  { typ = MTVInteger; iv = (int_8)v;  dv = (r_8)v;  dv_im = 0.;  return(*this); }
   inline MuTyV & operator= (uint_8 v)  { typ = MTVInteger; iv = (int_8)v;  dv = (r_8)v;  dv_im = 0.;  return(*this); }
+  inline MuTyV & operator= (int_1 v)  { typ = MTVInteger; iv = (int_8)v;  dv = (r_8)v;  dv_im = 0.;  return(*this); }
   inline MuTyV & operator= (int_2 v)  { typ = MTVInteger; iv = (int_8)v;  dv = (r_8)v;  dv_im = 0.;  return(*this); }
   inline MuTyV & operator= (int_4 v)  { typ = MTVInteger; iv = (int_8)v;  dv = (r_8)v;  dv_im = 0.;  return(*this); }
@@ -68,7 +72,9 @@
          TimeStamp const& operator= (TimeStamp const & s);
 
+  inline operator uint_1() const { return((uint_1)iv); }
   inline operator uint_2() const { return((uint_2)iv); }
   inline operator uint_4() const { return((uint_4)iv); }
   inline operator uint_8() const { return((uint_8)iv); }
+  inline operator int_1()  const { return((int_1)iv); }
   inline operator int_2()  const { return((int_2)iv); }
   inline operator int_4()  const { return((int_4)iv); }
@@ -82,8 +88,10 @@
          operator TimeStamp() const ; 
 
+  inline uint_1 Convert(uint_1& x) const { x = (uint_1)iv; return x; }
   inline uint_2 Convert(uint_2& x) const { x = (uint_2)iv; return x; }
   inline uint_4 Convert(uint_4& x) const { x = (uint_4)iv; return x; }
   inline uint_8 Convert(uint_8& x) const { x = (uint_8)iv; return x; }
-  inline int_4 Convert(int_2& x) const { x = (int_2)iv; return x; }
+  inline int_1 Convert(int_1& x) const { x = (int_1)iv; return x; }
+  inline int_2 Convert(int_2& x) const { x = (int_2)iv; return x; }
   inline int_4 Convert(int_4& x) const { x = (int_4)iv; return x; }
   inline int_8 Convert(int_8& x) const { x = iv; return x; }
Index: /trunk/SophyaLib/BaseTools/ndatablock.cc
===================================================================
--- /trunk/SophyaLib/BaseTools/ndatablock.cc	(revision 3660)
+++ /trunk/SophyaLib/BaseTools/ndatablock.cc	(revision 3661)
@@ -812,4 +812,5 @@
 #pragma define_template NDataBlock<uint_1>
 #pragma define_template NDataBlock<uint_2>
+#pragma define_template NDataBlock<int_1>
 #pragma define_template NDataBlock<int_2>
 #pragma define_template NDataBlock<int_4>
@@ -827,4 +828,5 @@
 template class NDataBlock<uint_1>;
 template class NDataBlock<uint_2>;
+template class NDataBlock<int_1>;
 template class NDataBlock<int_2>;
 template class NDataBlock<int_4>;
Index: /trunk/SophyaLib/NTools/cimage.cc
===================================================================
--- /trunk/SophyaLib/NTools/cimage.cc	(revision 3660)
+++ /trunk/SophyaLib/NTools/cimage.cc	(revision 3661)
@@ -187,7 +187,9 @@
 #pragma define_template Image< complex<r_8> > 
 
+#pragma define_template FIO_Image<uint_1>
 #pragma define_template FIO_Image<uint_2>
 #pragma define_template FIO_Image<uint_4>
 #pragma define_template FIO_Image<uint_8>
+#pragma define_template FIO_Image<int_1>
 #pragma define_template FIO_Image<int_2>
 #pragma define_template FIO_Image<int_4>
@@ -212,7 +214,9 @@
 template class Image< complex<r_8> >;
 
+template class FIO_Image<uint_1>;
 template class FIO_Image<uint_2>;
 template class FIO_Image<uint_4>;
 template class FIO_Image<uint_8>;
+template class FIO_Image<int_1>;
 template class FIO_Image<int_2>;
 template class FIO_Image<int_4>;
Index: /trunk/SophyaLib/NTools/generaldata.cc
===================================================================
--- /trunk/SophyaLib/NTools/generaldata.cc	(revision 3660)
+++ /trunk/SophyaLib/NTools/generaldata.cc	(revision 3661)
@@ -980,7 +980,8 @@
 if(str[0]=='o') return 2*NVar()+2;
 if(str[0]=='x') {sscanf(str,"x%d",&k); return k;}
-if(str[0]=='e')
+if(str[0]=='e') {
   if(str[1]=='y') return 2*NVar()+1;
   else if(str[1]=='x') {sscanf(str,"ex%d",&k); return NVar()+k;}
+ }
 return -1;
 }
Index: /trunk/SophyaLib/NTools/objfitter.cc
===================================================================
--- /trunk/SophyaLib/NTools/objfitter.cc	(revision 3660)
+++ /trunk/SophyaLib/NTools/objfitter.cc	(revision 3661)
@@ -454,7 +454,9 @@
 ///////////////////////////////////////////////////////////////
 #ifdef __CXX_PRAGMA_TEMPLATES__
+#pragma define_template ArrayFitter<uint_1>
 #pragma define_template ArrayFitter<uint_2>
 #pragma define_template ArrayFitter<uint_4>
 #pragma define_template ArrayFitter<uint_8>
+#pragma define_template ArrayFitter<int_1>
 #pragma define_template ArrayFitter<int_2>
 #pragma define_template ArrayFitter<int_4>
@@ -473,7 +475,9 @@
 #if defined(ANSI_TEMPLATES) || defined(GNU_TEMPLATES)
 namespace SOPHYA {
+template class ArrayFitter<uint_1>;
 template class ArrayFitter<uint_2>;
 template class ArrayFitter<uint_4>;
 template class ArrayFitter<uint_8>;
+template class ArrayFitter<int_1>;
 template class ArrayFitter<int_2>;
 template class ArrayFitter<int_4>;
Index: /trunk/SophyaLib/TArray/fioarr.cc
===================================================================
--- /trunk/SophyaLib/TArray/fioarr.cc	(revision 3660)
+++ /trunk/SophyaLib/TArray/fioarr.cc	(revision 3661)
@@ -217,8 +217,9 @@
 #ifdef __CXX_PRAGMA_TEMPLATES__
 // Instances des delegues FileIO (PPersist)
-// #pragma define_template FIO_TArray<uint_1>
+#pragma define_template FIO_TArray<uint_1>
 #pragma define_template FIO_TArray<uint_2>
 #pragma define_template FIO_TArray<uint_4>
 #pragma define_template FIO_TArray<uint_8>
+#pragma define_template FIO_TArray<int_1>
 #pragma define_template FIO_TArray<int_2>
 #pragma define_template FIO_TArray<int_4>
@@ -233,8 +234,9 @@
 namespace SOPHYA {
 // Instances des delegues FileIO (PPersist)
-// template class FIO_TArray<uint_1>;
+template class FIO_TArray<uint_1>;
 template class FIO_TArray<uint_2>;
 template class FIO_TArray<uint_4>;
 template class FIO_TArray<uint_8>;
+template class FIO_TArray<int_1>;
 template class FIO_TArray<int_2>;
 template class FIO_TArray<int_4>;
Index: /trunk/SophyaLib/TArray/tarray.cc
===================================================================
--- /trunk/SophyaLib/TArray/tarray.cc	(revision 3660)
+++ /trunk/SophyaLib/TArray/tarray.cc	(revision 3661)
@@ -1639,10 +1639,9 @@
 ///////////////////////////////////////////////////////////////
 #ifdef __CXX_PRAGMA_TEMPLATES__
-/*
 #pragma define_template TArray<uint_1>
-*/
 #pragma define_template TArray<uint_2>
 #pragma define_template TArray<uint_4>
 #pragma define_template TArray<uint_8>
+#pragma define_template TArray<int_1>
 #pragma define_template TArray<int_2>
 #pragma define_template TArray<int_4>
@@ -1655,10 +1654,9 @@
 
 #if defined(ANSI_TEMPLATES) || defined(GNU_TEMPLATES)
-/*
 template class TArray<uint_1>; 
-*/
 template class TArray<uint_2>;
 template class TArray<uint_4>;
 template class TArray<uint_8>;
+template class TArray<int_1>; 
 template class TArray<int_2>;  
 template class TArray<int_4>;
Index: /trunk/SophyaLib/TArray/tarrinit.cc
===================================================================
--- /trunk/SophyaLib/TArray/tarrinit.cc	(revision 3660)
+++ /trunk/SophyaLib/TArray/tarrinit.cc	(revision 3661)
@@ -33,6 +33,14 @@
   
 
-  //  PPRegister(FIO_TArray<uint_1>);
-  //  DObjRegister(FIO_TArray<uint_1>, TArray<uint_1>);
+  PPRegister(FIO_TArray<uint_1>);
+  DObjRegister(FIO_TArray<uint_1>, TArray<uint_1>);
+  DObjRegister(FIO_TArray<uint_1>, TMatrix<uint_1>);
+  DObjRegister(FIO_TArray<uint_1>, TVector<uint_1>);
+
+  PPRegister(FIO_TArray<int_1>);
+  DObjRegister(FIO_TArray<int_1>, TArray<int_1>);
+  DObjRegister(FIO_TArray<int_1>, TMatrix<int_1>);
+  DObjRegister(FIO_TArray<int_1>, TVector<int_1>);
+
   PPRegister(FIO_TArray<uint_2>);
   DObjRegister(FIO_TArray<uint_2>, TArray<uint_2>);
@@ -45,4 +53,9 @@
   DObjRegister(FIO_TArray<int_2>, TVector<int_2>);
 
+  PPRegister(FIO_TArray<uint_4>);
+  DObjRegister(FIO_TArray<uint_4>, TArray<uint_4>);
+  DObjRegister(FIO_TArray<uint_4>, TMatrix<uint_4>);
+  DObjRegister(FIO_TArray<uint_4>, TVector<uint_4>);
+
   PPRegister(FIO_TArray<int_4>);
   DObjRegister(FIO_TArray<int_4>, TArray<int_4>);
@@ -50,18 +63,13 @@
   DObjRegister(FIO_TArray<int_4>, TVector<int_4>);
 
+  PPRegister(FIO_TArray<uint_8>);
+  DObjRegister(FIO_TArray<uint_8>, TArray<uint_8>);
+  DObjRegister(FIO_TArray<uint_8>, TMatrix<uint_8>);
+  DObjRegister(FIO_TArray<uint_8>, TVector<uint_8>);
+
   PPRegister(FIO_TArray<int_8>);
   DObjRegister(FIO_TArray<int_8>, TArray<int_8>);
   DObjRegister(FIO_TArray<int_8>, TMatrix<int_8>);
   DObjRegister(FIO_TArray<int_8>, TVector<int_8>);
-
-  PPRegister(FIO_TArray<uint_4>);
-  DObjRegister(FIO_TArray<uint_4>, TArray<uint_4>);
-  DObjRegister(FIO_TArray<uint_4>, TMatrix<uint_4>);
-  DObjRegister(FIO_TArray<uint_4>, TVector<uint_4>);
-
-  PPRegister(FIO_TArray<uint_8>);
-  DObjRegister(FIO_TArray<uint_8>, TArray<uint_8>);
-  DObjRegister(FIO_TArray<uint_8>, TMatrix<uint_8>);
-  DObjRegister(FIO_TArray<uint_8>, TVector<uint_8>);
 
   PPRegister(FIO_TArray<r_4>);
Index: /trunk/SophyaLib/TArray/tmatrix.cc
===================================================================
--- /trunk/SophyaLib/TArray/tmatrix.cc	(revision 3660)
+++ /trunk/SophyaLib/TArray/tmatrix.cc	(revision 3661)
@@ -1,3 +1,3 @@
-// $Id: tmatrix.cc,v 1.37 2006-11-02 14:57:20 ansari Exp $
+// $Id: tmatrix.cc,v 1.38 2009-10-23 19:48:27 cmv Exp $
 //                         C.Magneville          04/99
 #include "sopnamsp.h"
@@ -672,7 +672,9 @@
 ///////////////////////////////////////////////////////////////
 #ifdef __CXX_PRAGMA_TEMPLATES__
+#pragma define_template TMatrix<uint_1>
 #pragma define_template TMatrix<uint_2>
 #pragma define_template TMatrix<uint_4>
 #pragma define_template TMatrix<uint_8>
+#pragma define_template TMatrix<int_1>
 #pragma define_template TMatrix<int_2>
 #pragma define_template TMatrix<int_4>
@@ -686,7 +688,9 @@
 #if defined(ANSI_TEMPLATES) || defined(GNU_TEMPLATES)
 namespace SOPHYA {
+template class TMatrix<uint_1>;
 template class TMatrix<uint_2>;
 template class TMatrix<uint_4>;
 template class TMatrix<uint_8>;
+template class TMatrix<int_1>;
 template class TMatrix<int_2>;
 template class TMatrix<int_4>;
Index: /trunk/SophyaLib/TArray/tvector.cc
===================================================================
--- /trunk/SophyaLib/TArray/tvector.cc	(revision 3660)
+++ /trunk/SophyaLib/TArray/tvector.cc	(revision 3661)
@@ -1,3 +1,3 @@
-// $Id: tvector.cc,v 1.22 2006-04-03 08:55:26 ansari Exp $
+// $Id: tvector.cc,v 1.23 2009-10-23 19:48:27 cmv Exp $
 //                         C.Magneville          04/99
 #include "sopnamsp.h"
@@ -245,7 +245,9 @@
 ///////////////////////////////////////////////////////////////
 #ifdef __CXX_PRAGMA_TEMPLATES__
+#pragma define_template TVector<uint_1>
 #pragma define_template TVector<uint_2>
 #pragma define_template TVector<uint_4>
 #pragma define_template TVector<uint_8>
+#pragma define_template TVector<int_1>
 #pragma define_template TVector<int_2>
 #pragma define_template TVector<int_4>
@@ -259,7 +261,9 @@
 #if defined(ANSI_TEMPLATES) || defined(GNU_TEMPLATES)
 namespace SOPHYA {
+template class TVector<uint_1>;
 template class TVector<uint_2>;
 template class TVector<uint_4>;
 template class TVector<uint_8>;
+template class TVector<int_1>;
 template class TVector<int_2>;
 template class TVector<int_4>;
Index: /trunk/SophyaPI/PIext/nomtarradapter.cc
===================================================================
--- /trunk/SophyaPI/PIext/nomtarradapter.cc	(revision 3660)
+++ /trunk/SophyaPI/PIext/nomtarradapter.cc	(revision 3661)
@@ -497,7 +497,9 @@
 
 #ifdef __CXX_PRAGMA_TEMPLATES__
+#pragma define_template NOMAdapter_TArray<uint_1>
 #pragma define_template NOMAdapter_TArray<uint_2>
 #pragma define_template NOMAdapter_TArray<uint_4>
 #pragma define_template NOMAdapter_TArray<uint_8>
+#pragma define_template NOMAdapter_TArray<int_1>
 #pragma define_template NOMAdapter_TArray<int_2>
 #pragma define_template NOMAdapter_TArray<int_4>
@@ -507,7 +509,9 @@
 #pragma define_template NOMAdapter_TArray< complex<r_4> >
 #pragma define_template NOMAdapter_TArray< complex<r_8> >
+#pragma define_template NTupInt_TArray<uint_1>
 #pragma define_template NTupInt_TArray<uint_2>
 #pragma define_template NTupInt_TArray<uint_4>
 #pragma define_template NTupInt_TArray<uint_8>
+#pragma define_template NTupInt_TArray<int_1>
 #pragma define_template NTupInt_TArray<int_2>
 #pragma define_template NTupInt_TArray<int_4>
@@ -520,7 +524,9 @@
 
 #if defined(ANSI_TEMPLATES) 
+template class NOMAdapter_TArray<uint_1>;
 template class NOMAdapter_TArray<uint_2>;
 template class NOMAdapter_TArray<uint_4>;
 template class NOMAdapter_TArray<uint_8>;
+template class NOMAdapter_TArray<int_1>;
 template class NOMAdapter_TArray<int_2>;
 template class NOMAdapter_TArray<int_4>;
@@ -530,7 +536,9 @@
 template class NOMAdapter_TArray< complex<r_4> >;
 template class NOMAdapter_TArray< complex<r_8> >;
+template class NTupInt_TArray<uint_1>;
 template class NTupInt_TArray<uint_2>;
 template class NTupInt_TArray<uint_4>;
 template class NTupInt_TArray<uint_8>;
+template class NTupInt_TArray<int_1>;
 template class NTupInt_TArray<int_2>;
 template class NTupInt_TArray<int_4>;
Index: /trunk/SophyaPI/PIext/nomtmatvecadapter.cc
===================================================================
--- /trunk/SophyaPI/PIext/nomtmatvecadapter.cc	(revision 3660)
+++ /trunk/SophyaPI/PIext/nomtmatvecadapter.cc	(revision 3661)
@@ -494,7 +494,9 @@
 
 #ifdef __CXX_PRAGMA_TEMPLATES__
+#pragma define_template NOMAdapter_TMatrix<uint_1>
 #pragma define_template NOMAdapter_TMatrix<uint_2>
 #pragma define_template NOMAdapter_TMatrix<uint_4>
 #pragma define_template NOMAdapter_TMatrix<uint_8>
+#pragma define_template NOMAdapter_TMatrix<int_1>
 #pragma define_template NOMAdapter_TMatrix<int_2>
 #pragma define_template NOMAdapter_TMatrix<int_4>
@@ -504,7 +506,9 @@
 #pragma define_template NOMAdapter_TMatrix< complex<r_4> >
 #pragma define_template NOMAdapter_TMatrix< complex<r_8> >
+#pragma define_template NTupInt_TMatrix<uint_1>
 #pragma define_template NTupInt_TMatrix<uint_2>
 #pragma define_template NTupInt_TMatrix<uint_4>
 #pragma define_template NTupInt_TMatrix<uint_8>
+#pragma define_template NTupInt_TMatrix<int_1>
 #pragma define_template NTupInt_TMatrix<int_2>
 #pragma define_template NTupInt_TMatrix<int_4>
@@ -517,7 +521,9 @@
 
 #if defined(ANSI_TEMPLATES) 
+template class NOMAdapter_TMatrix<uint_1>;
 template class NOMAdapter_TMatrix<uint_2>;
 template class NOMAdapter_TMatrix<uint_4>;
 template class NOMAdapter_TMatrix<uint_8>;
+template class NOMAdapter_TMatrix<int_1>;
 template class NOMAdapter_TMatrix<int_2>;
 template class NOMAdapter_TMatrix<int_4>;
@@ -527,7 +533,9 @@
 template class NOMAdapter_TMatrix< complex<r_4> >;
 template class NOMAdapter_TMatrix< complex<r_8> >;
+template class NTupInt_TMatrix<uint_1>;
 template class NTupInt_TMatrix<uint_2>;
 template class NTupInt_TMatrix<uint_4>;
 template class NTupInt_TMatrix<uint_8>;
+template class NTupInt_TMatrix<int_1>;
 template class NTupInt_TMatrix<int_2>;
 template class NTupInt_TMatrix<int_4>;
Index: /trunk/SophyaPI/PIext/piinit.cc
===================================================================
--- /trunk/SophyaPI/PIext/piinit.cc	(revision 3660)
+++ /trunk/SophyaPI/PIext/piinit.cc	(revision 3661)
@@ -57,7 +57,9 @@
 
 //  Octobre 2008 : prise en charge tableaux/matrice/vecteurs en uint_4 uint_8 
+  serv->RegisterClass(new TArray<uint_1>, new NOMAdapter_TArray<uint_1> );
   serv->RegisterClass(new TArray<uint_2>, new NOMAdapter_TArray<uint_2> );
   serv->RegisterClass(new TArray<uint_4>, new NOMAdapter_TArray<uint_4> );
   serv->RegisterClass(new TArray<uint_8>, new NOMAdapter_TArray<uint_8> );
+  serv->RegisterClass(new TArray<int_1>, new NOMAdapter_TArray<int_1> );
   serv->RegisterClass(new TArray<int_2>, new NOMAdapter_TArray<int_2> );
   serv->RegisterClass(new TArray<int_4>, new NOMAdapter_TArray<int_4> );
@@ -68,4 +70,6 @@
   serv->RegisterClass(new TArray<complex<r_8> >, new NOMAdapter_TArray<complex<r_8> > );
 
+  serv->RegisterClass(new TVector<uint_1>, new NOMAdapter_TMatrix<uint_1> );
+  serv->RegisterClass(new TMatrix<uint_1>, new NOMAdapter_TMatrix<uint_1> );
   serv->RegisterClass(new TVector<uint_2>, new NOMAdapter_TMatrix<uint_2> );
   serv->RegisterClass(new TMatrix<uint_2>, new NOMAdapter_TMatrix<uint_2> );
@@ -74,4 +78,6 @@
   serv->RegisterClass(new TVector<uint_8>, new NOMAdapter_TMatrix<uint_8> );
   serv->RegisterClass(new TMatrix<uint_8>, new NOMAdapter_TMatrix<uint_8> );
+  serv->RegisterClass(new TVector<int_1>, new NOMAdapter_TMatrix<int_1> );
+  serv->RegisterClass(new TMatrix<int_1>, new NOMAdapter_TMatrix<int_1> );
   serv->RegisterClass(new TVector<int_2>, new NOMAdapter_TMatrix<int_2> );
   serv->RegisterClass(new TMatrix<int_2>, new NOMAdapter_TMatrix<int_2> );
Index: /trunk/SophyaPI/PIext/pitvmaad.cc
===================================================================
--- /trunk/SophyaPI/PIext/pitvmaad.cc	(revision 3660)
+++ /trunk/SophyaPI/PIext/pitvmaad.cc	(revision 3661)
@@ -134,7 +134,9 @@
 
 #ifdef __CXX_PRAGMA_TEMPLATES__
+#pragma define_template POTVectorAdapter< uint_1 >
 #pragma define_template POTVectorAdapter< uint_2 >
 #pragma define_template POTVectorAdapter< uint_4 >
 #pragma define_template POTVectorAdapter< uint_8 >
+#pragma define_template POTVectorAdapter< int_1 >
 #pragma define_template POTVectorAdapter< int_2 >
 #pragma define_template POTVectorAdapter< int_4 >
@@ -145,7 +147,9 @@
 #pragma define_template POTVectorAdapter< complex<double> > 
 
+#pragma define_template POTMatrixAdapter< uint_1 >
 #pragma define_template POTMatrixAdapter< uint_2 >
 #pragma define_template POTMatrixAdapter< uint_4 >
 #pragma define_template POTMatrixAdapter< uint_8 >
+#pragma define_template POTMatrixAdapter< int_1 >
 #pragma define_template POTMatrixAdapter< int_2 >
 #pragma define_template POTMatrixAdapter< int_4 >
@@ -158,7 +162,9 @@
 
 #if defined(ANSI_TEMPLATES)
+template class POTVectorAdapter< uint_1 >;
 template class POTVectorAdapter< uint_2 >;
 template class POTVectorAdapter< uint_4 >;
 template class POTVectorAdapter< uint_8 >;
+template class POTVectorAdapter< int_1 >;
 template class POTVectorAdapter< int_2 >;
 template class POTVectorAdapter< int_4 >;
@@ -169,7 +175,9 @@
 template class POTVectorAdapter< complex<double> >;
 
+template class POTMatrixAdapter< uint_1 >;
 template class POTMatrixAdapter< uint_2 >;
 template class POTMatrixAdapter< uint_4 >;
 template class POTMatrixAdapter< uint_8 >;
+template class POTMatrixAdapter< int_1 >;
 template class POTMatrixAdapter< int_2 >;
 template class POTMatrixAdapter< int_4 >;